diff --git a/docs/devel/tcg-ops.rst b/docs/devel/tcg-ops.rst
index 6a166c5665..c74849a231 100644
--- a/docs/devel/tcg-ops.rst
+++ b/docs/devel/tcg-ops.rst
@@ -151,7 +151,7 @@ Types
 Helpers
 =======
 
-Helpers are registered in a guest-specific ``helper.h``,
+Helpers are registered in a guest-specific ``helper.h.inc``,
 which is processed to generate ``tcg_gen_helper_*`` functions.
 With these functions it is possible to call a function taking
 i32, i64, i128 or pointer types.
diff --git a/include/exec/helper-gen.h b/include/exec/helper-gen.h
index f7ec155699..fdb3ec39f5 100644
--- a/include/exec/helper-gen.h
+++ b/include/exec/helper-gen.h
@@ -9,7 +9,7 @@
 
 #include "exec/helper-gen-common.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-gen.h.inc"
 #undef  HELPER_H
 
diff --git a/include/exec/helper-proto.h b/include/exec/helper-proto.h
index 6935cb4f16..fd061749be 100644
--- a/include/exec/helper-proto.h
+++ b/include/exec/helper-proto.h
@@ -9,7 +9,7 @@
 
 #include "exec/helper-proto-common.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-proto.h.inc"
 #undef  HELPER_H
 
diff --git a/target/alpha/helper.h b/target/alpha/helper.h.inc
similarity index 100%
rename from target/alpha/helper.h
rename to target/alpha/helper.h.inc
diff --git a/target/arm/helper.h b/target/arm/helper.h.inc
similarity index 100%
rename from target/arm/helper.h
rename to target/arm/helper.h.inc
diff --git a/target/avr/helper.h b/target/avr/helper.h.inc
similarity index 100%
rename from target/avr/helper.h
rename to target/avr/helper.h.inc
diff --git a/target/cris/helper.h b/target/cris/helper.h.inc
similarity index 100%
rename from target/cris/helper.h
rename to target/cris/helper.h.inc
diff --git a/target/hexagon/helper.h b/target/hexagon/helper.h.inc
similarity index 100%
rename from target/hexagon/helper.h
rename to target/hexagon/helper.h.inc
diff --git a/target/hppa/helper.h b/target/hppa/helper.h.inc
similarity index 100%
rename from target/hppa/helper.h
rename to target/hppa/helper.h.inc
diff --git a/target/i386/helper.h b/target/i386/helper.h.inc
similarity index 100%
rename from target/i386/helper.h
rename to target/i386/helper.h.inc
diff --git a/target/loongarch/helper.h b/target/loongarch/helper.h.inc
similarity index 100%
rename from target/loongarch/helper.h
rename to target/loongarch/helper.h.inc
diff --git a/target/m68k/helper.h b/target/m68k/helper.h.inc
similarity index 100%
rename from target/m68k/helper.h
rename to target/m68k/helper.h.inc
diff --git a/target/microblaze/helper.h b/target/microblaze/helper.h.inc
similarity index 100%
rename from target/microblaze/helper.h
rename to target/microblaze/helper.h.inc
diff --git a/target/mips/helper.h b/target/mips/helper.h.inc
similarity index 100%
rename from target/mips/helper.h
rename to target/mips/helper.h.inc
diff --git a/target/nios2/helper.h b/target/nios2/helper.h.inc
similarity index 100%
rename from target/nios2/helper.h
rename to target/nios2/helper.h.inc
diff --git a/target/openrisc/helper.h b/target/openrisc/helper.h.inc
similarity index 100%
rename from target/openrisc/helper.h
rename to target/openrisc/helper.h.inc
diff --git a/target/ppc/helper.h b/target/ppc/helper.h.inc
similarity index 100%
rename from target/ppc/helper.h
rename to target/ppc/helper.h.inc
diff --git a/target/riscv/helper.h b/target/riscv/helper.h.inc
similarity index 100%
rename from target/riscv/helper.h
rename to target/riscv/helper.h.inc
diff --git a/target/rx/helper.h b/target/rx/helper.h.inc
similarity index 100%
rename from target/rx/helper.h
rename to target/rx/helper.h.inc
diff --git a/target/s390x/helper.h b/target/s390x/helper.h.inc
similarity index 100%
rename from target/s390x/helper.h
rename to target/s390x/helper.h.inc
diff --git a/target/sh4/helper.h b/target/sh4/helper.h.inc
similarity index 100%
rename from target/sh4/helper.h
rename to target/sh4/helper.h.inc
diff --git a/target/sparc/helper.h b/target/sparc/helper.h.inc
similarity index 100%
rename from target/sparc/helper.h
rename to target/sparc/helper.h.inc
diff --git a/target/tricore/helper.h b/target/tricore/helper.h.inc
similarity index 100%
rename from target/tricore/helper.h
rename to target/tricore/helper.h.inc
diff --git a/target/xtensa/helper.h b/target/xtensa/helper.h.inc
similarity index 100%
rename from target/xtensa/helper.h
rename to target/xtensa/helper.h.inc
diff --git a/target/alpha/translate.c b/target/alpha/translate.c
index 1f7dd078d8..1fd9c18262 100644
--- a/target/alpha/translate.c
+++ b/target/alpha/translate.c
@@ -30,7 +30,7 @@
 #include "exec/translator.h"
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/arm/machine.c b/target/arm/machine.c
index fc4a4a4064..6d9afc5f00 100644
--- a/target/arm/machine.c
+++ b/target/arm/machine.c
@@ -462,7 +462,7 @@ static bool pmsav7_rnr_needed(void *opaque)
     CPUARMState *env = &cpu->env;
 
     /* For R profile cores pmsav7.rnr is migrated via the cpreg
-     * "RGNR" definition in helper.h. For M profile we have to
+     * "RGNR" definition in helper.h.inc. For M profile we have to
      * migrate it separately.
      */
     return arm_feature(env, ARM_FEATURE_M);
diff --git a/target/arm/tcg/translate.c b/target/arm/tcg/translate.c
index a68d3c7f6d..308f6a8513 100644
--- a/target/arm/tcg/translate.c
+++ b/target/arm/tcg/translate.c
@@ -29,7 +29,7 @@
 #include "cpregs.h"
 #include "exec/helper-proto.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/avr/translate.c b/target/avr/translate.c
index ef2edd7415..4205bf94b3 100644
--- a/target/avr/translate.c
+++ b/target/avr/translate.c
@@ -30,7 +30,7 @@
 #include "exec/log.h"
 #include "exec/translator.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/cris/translate.c b/target/cris/translate.c
index 1445cd8bb5..3b5686cbb0 100644
--- a/target/cris/translate.c
+++ b/target/cris/translate.c
@@ -37,7 +37,7 @@
 #include "exec/helper-gen.h"
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/hexagon/translate.c b/target/hexagon/translate.c
index 708339198e..3d5c628885 100644
--- a/target/hexagon/translate.c
+++ b/target/hexagon/translate.c
@@ -33,7 +33,7 @@
 #include "genptr.h"
 #include "printinsn.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/hppa/translate.c b/target/hppa/translate.c
index d33813d173..f2e5ace845 100644
--- a/target/hppa/translate.c
+++ b/target/hppa/translate.c
@@ -29,7 +29,7 @@
 #include "exec/translator.h"
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/i386/tcg/translate.c b/target/i386/tcg/translate.c
index 5cf14311a6..61fa64efa7 100644
--- a/target/i386/tcg/translate.c
+++ b/target/i386/tcg/translate.c
@@ -34,7 +34,7 @@
 
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/loongarch/translate.c b/target/loongarch/translate.c
index 3146a2d4ac..fdbb9d25ea 100644
--- a/target/loongarch/translate.c
+++ b/target/loongarch/translate.c
@@ -23,7 +23,7 @@
 TCGv cpu_gpr[32], cpu_pc;
 static TCGv cpu_lladdr, cpu_llval;
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/m68k/translate.c b/target/m68k/translate.c
index 551ef9e52a..8594313e8f 100644
--- a/target/m68k/translate.c
+++ b/target/m68k/translate.c
@@ -34,7 +34,7 @@
 #include "exec/log.h"
 #include "fpu/softfloat.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/microblaze/translate.c b/target/microblaze/translate.c
index 7e7f837c63..ffb40421a0 100644
--- a/target/microblaze/translate.c
+++ b/target/microblaze/translate.c
@@ -31,7 +31,7 @@
 
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/mips/tcg/translate.c b/target/mips/tcg/translate.c
index 74af91e4f5..1dfffe1c6f 100644
--- a/target/mips/tcg/translate.c
+++ b/target/mips/tcg/translate.c
@@ -32,7 +32,7 @@
 #include "disas/disas.h"
 #include "fpu_helper.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/nios2/translate.c b/target/nios2/translate.c
index a365ad8293..6f81efe90b 100644
--- a/target/nios2/translate.c
+++ b/target/nios2/translate.c
@@ -34,7 +34,7 @@
 #include "qemu/qemu-print.h"
 #include "semihosting/semihost.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/openrisc/translate.c b/target/openrisc/translate.c
index 7760329e75..f5e8a25977 100644
--- a/target/openrisc/translate.c
+++ b/target/openrisc/translate.c
@@ -34,7 +34,7 @@
 
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/ppc/translate.c b/target/ppc/translate.c
index 37fd431870..598759f813 100644
--- a/target/ppc/translate.c
+++ b/target/ppc/translate.c
@@ -41,7 +41,7 @@
 #include "qemu/qemu-print.h"
 #include "qapi/error.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/riscv/translate.c b/target/riscv/translate.c
index 933b11c50d..e27df3c9af 100644
--- a/target/riscv/translate.c
+++ b/target/riscv/translate.c
@@ -33,7 +33,7 @@
 #include "instmap.h"
 #include "internals.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/rx/translate.c b/target/rx/translate.c
index 08cabbde61..5b60082749 100644
--- a/target/rx/translate.c
+++ b/target/rx/translate.c
@@ -28,7 +28,7 @@
 #include "exec/translator.h"
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/s390x/tcg/translate.c b/target/s390x/tcg/translate.c
index 7c549cd8d0..7db663c915 100644
--- a/target/s390x/tcg/translate.c
+++ b/target/s390x/tcg/translate.c
@@ -45,7 +45,7 @@
 #include "exec/log.h"
 #include "qemu/atomic128.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/sh4/translate.c b/target/sh4/translate.c
index 49c87d7a01..df4c721cee 100644
--- a/target/sh4/translate.c
+++ b/target/sh4/translate.c
@@ -29,7 +29,7 @@
 #include "exec/log.h"
 #include "qemu/qemu-print.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/sparc/translate.c b/target/sparc/translate.c
index bad2ec90a0..99efd3ae87 100644
--- a/target/sparc/translate.c
+++ b/target/sparc/translate.c
@@ -33,7 +33,7 @@
 #include "exec/log.h"
 #include "asi.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/tricore/translate.c b/target/tricore/translate.c
index 8e4f99478c..ed40a2c8ef 100644
--- a/target/tricore/translate.c
+++ b/target/tricore/translate.c
@@ -33,7 +33,7 @@
 #include "exec/translator.h"
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 
diff --git a/target/xtensa/translate.c b/target/xtensa/translate.c
index b7386ff0f0..68495fc983 100644
--- a/target/xtensa/translate.c
+++ b/target/xtensa/translate.c
@@ -45,7 +45,7 @@
 
 #include "exec/log.h"
 
-#define HELPER_H "helper.h"
+#define HELPER_H "helper.h.inc"
 #include "exec/helper-info.c.inc"
 #undef  HELPER_H
 